﻿Imports Microsoft.Office.Interop
Imports Forms_Library

' Select Test - Users choose a category and a level from the drop down boxes and open the testing
' page for either a record test or a practice test.
Public Class SelectTest
    ' members...
    Public allProblems As New ArrayList
    Public addLevels As New ArrayList
    Public subLevels As New ArrayList
    Public divLevels As New ArrayList
    Public multLevels As New ArrayList
    Public fracLevels As New ArrayList
    Public decLevels As New ArrayList

    Public CategoryChoice As String
    Public LevelChoice As String ' Turn this into an Integer?
    Public Practice As Boolean ' indicator flag for practice tests
    Private _userId As Integer


    ' Select Category - when the user selects a category from the dropdown, the options in the Level
    ' dropdown should be updated
    Private Sub cboCategory_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboCategory.SelectedIndexChanged
        Dim intSelectedIndex As Integer
        intSelectedIndex = cboCategory.SelectedIndex
        Dim objSelectedItem As Object
        objSelectedItem = cboCategory.SelectedIndex

        Dim comboBox As ComboBox = CType(sender, ComboBox)
        ' Save selected category
        Dim selectedIndex = CType(cboCategory.SelectedIndex, String)

        ' TODO: get the list of levels for selected category

        ' For now... the lists are levels 1-5 and 1-2
        Dim forNowLevels1() As String
        forNowLevels1 = New String() {"4", _
                                  "5"}
        Dim forNowLevels2() As String
        'forNowLevels2 = New String() {"1", _
        '                             "2"}

        ' For now.. This is just a test...
        ' MessageBox.Show("Woot!  You don't entirely fail at life!")

        Dim addition As String
        addition = "Addition"
        Dim intResult As Integer
        intResult = StrComp(addition, selectedIndex, vbTextCompare)
        'MessageBox.Show("If the result is Zero, we can do math:" & intResult)

        If intResult = 0 Then
            MessageBox.Show("You got into the addition loop.")
            cboLevel.Items.AddRange(forNowLevels1)
        End If

        cboLevel.Items.Clear() '' clear the level box
        '' from here to the end, the event method updates the level box with the appropriate levels
        ''for the catagorie selected
        If cboCategory.Text.Equals("Addition") Then
            cboLevel.Items.AddRange(addLevels.ToArray)
        End If

        If cboCategory.Text.Equals("Subtraction") Then
            cboLevel.Items.AddRange(subLevels.ToArray)
        End If

        If cboCategory.Text.Equals("Division") Then
            cboLevel.Items.AddRange(divLevels.ToArray)
        End If

        If cboCategory.Text.Equals("Multiplication") Then
            cboLevel.Items.AddRange(multLevels.ToArray)
        End If

        If cboCategory.Text.Equals("Fraction") Then
            cboLevel.Items.AddRange(fracLevels.ToArray)
        End If

        If cboCategory.Text.Equals("Decimal") Then
            cboLevel.Items.AddRange(decLevels.ToArray)
        End If
    End Sub

    ' Record Test - open Testing Page to begin record test with the selected category and level
    ''TODO: make the array of tests here.
    Private Sub btnRecordTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecordTest.Click
        ' check that a category was selected
        If cboCategory.Text.Length > 0 Then
            ' check that a level was selected
            If cboLevel.Text.Length > 0 Then
                ' set the Category and Level
                CategoryChoice = cboCategory.Text
                LevelChoice = cboLevel.Text
                ' Indicate that this is a record test
                Practice = False
                ' Open the Testing Page
                ' open Testing Page.
                MessageBox.Show("Going to testing Page")
                Dim oForm As TestingPage
                oForm = New TestingPage()
                oForm.Show()
                oForm = Nothing
            Else
                ' tell the user that the level hasn't been chosen list 1

                MessageBox.Show("Please choose a level.")
            End If
        Else
            ' tell the user that the category hasn't been chosen
            MessageBox.Show("Please choose a category.")
        End If
    End Sub

    ' Practice Test - open Testing Page to begin practice test with the selected category and level
    Private Sub btnPracticeTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPracticeTest.Click
        ' check that a category was selected
        If cboCategory.Text.Length > 0 Then
            ' check that a level was selected
            If cboLevel.Text.Length > 0 Then
                ' set the Category and Level
                CategoryChoice = cboCategory.Text
                LevelChoice = cboLevel.Text
                ' Indicate that this is a record test
                Practice = True
                ' open testing page.
                MessageBox.Show("Going to the testing page")
                Dim oForm As TestingPage
                oForm = New TestingPage()
                oForm.Show()
                oForm = Nothing
            Else
                ' tell the user that the level hasn't been chosen
                MessageBox.Show("Please choose a level.")
            End If
        Else
            ' tell the user that the category hasn't been chosen
            MessageBox.Show("Please choose a category.")
        End If
    End Sub

    '' this Sub reads in an xcel book and creates a master list of all of the problems contained within it
    Public Sub xcelInit()
        Dim temp As New MathProblem
        Dim getOut As Boolean '' sentinal boolean for the  while loop
        Dim irow As Integer
        Dim xl As New Excel.Application
        Dim xlsheet As New Excel.Worksheet
        Dim xlwbook As Excel.Workbook
        xlwbook = xl.Workbooks.Open("C:\Users\Craig\MQP\LSA.xlsx")

        ''This commented out code is for an old default method of finding all problems in the excel sheet
        ''The new code below uses a restrained system that methodically sorts through only the cells that we need
        'For Each cell In xlsheet.Cells
        'Dim temp As New MathProblem
        'If (cell.Value <> "") Then
        'MessageBox.Show(cell.Value)
        'temp.original = cell.Value
        'temp.getInternals()
        'MessageBox.Show(temp.original.ToString)
        'allProblems.Add(temp)
        'End If
        'If cell.Value = "" Then GoTo ESCAPE
        'MessageBox.Show("AAAAHHHHH")
        'Next
        xlsheet = xlwbook.Worksheets("Addition")
        temp = New MathProblem
        irow = 2 '' to skip the title row
        getOut = False
        While getOut.Equals(False)
            ''MessageBox.Show(xlsheet.Cells(irow, 1).Value)
            If Not xlsheet.Cells(irow, 1).Value = vbNullString Then '' check for empty cell
                temp.level = xlsheet.Cells(irow, 1).Value '' get level in first box
                temp.original = xlsheet.Cells(irow, 2).Value.ToString '' get mathProblame in 2nd
                temp.type = "Addition" '' set the type
                ''  MessageBox.Show(temp.original.ToString + "Level " + temp.level.ToString)
                If Not (addLevels.Contains(temp.level)) Then addLevels.Add(temp.level) '' if the level is unique, add it to the levels to be displayed
                allProblems.Add(temp)
                irow = irow + 1
                temp = New MathProblem
            Else
                getOut = True
            End If
        End While

        xlsheet = xlwbook.Worksheets("Subtraction")
        temp = New MathProblem
        irow = 2 '' to skip the title row
        getOut = False
        While getOut.Equals(False)
            ''MessageBox.Show(xlsheet.Cells(irow, 1).Value)
            If Not xlsheet.Cells(irow, 1).Value = vbNullString Then '' check for empty cell
                temp.level = xlsheet.Cells(irow, 1).Value
                temp.original = xlsheet.Cells(irow, 2).Value.ToString
                temp.type = "Subtraction"
                ''     MessageBox.Show(temp.original.ToString + "Level " + temp.level.ToString)
                If Not (subLevels.Contains(temp.level)) Then subLevels.Add(temp.level)
                allProblems.Add(temp)
                irow = irow + 1
                temp = New MathProblem
            Else
                getOut = True
            End If
        End While

        xlsheet = xlwbook.Worksheets("Multiplication")
        temp = New MathProblem
        irow = 2 '' to skip the title row
        getOut = False
        While getOut.Equals(False)
            ''MessageBox.Show(xlsheet.Cells(irow, 1).Value)
            If Not xlsheet.Cells(irow, 1).Value = vbNullString Then '' check for empty cell
                temp.level = xlsheet.Cells(irow, 1).Value
                temp.original = xlsheet.Cells(irow, 2).Value.ToString
                temp.type = "Multiplication"
                ''     MessageBox.Show(temp.original.ToString + "Level " + temp.level.ToString)
                If Not (multLevels.Contains(temp.level)) Then multLevels.Add(temp.level)
                allProblems.Add(temp)
                irow = irow + 1
                temp = New MathProblem
            Else
                getOut = True
            End If
        End While

        xlsheet = xlwbook.Worksheets("Division")
        temp = New MathProblem
        irow = 2 '' to skip the title row
        getOut = False
        While getOut.Equals(False)
            ''MessageBox.Show(xlsheet.Cells(irow, 1).Value)
            If Not xlsheet.Cells(irow, 1).Value = vbNullString Then '' check for empty cell
                temp.level = xlsheet.Cells(irow, 1).Value
                temp.original = xlsheet.Cells(irow, 2).Value.ToString
                temp.type = "Division"
                ''       MessageBox.Show(temp.original.ToString + "Level " + temp.level.ToString)
                If Not (divLevels.Contains(temp.level)) Then divLevels.Add(temp.level)
                allProblems.Add(temp)
                irow = irow + 1
                temp = New MathProblem
            Else
                getOut = True
            End If
        End While

        xlsheet = xlwbook.Worksheets("Decimals")
        temp = New MathProblem
        irow = 2 '' to skip the title row
        getOut = False
        While getOut.Equals(False)
            ''MessageBox.Show(xlsheet.Cells(irow, 1).Value)
            If Not xlsheet.Cells(irow, 1).Value = vbNullString Then '' check for empty cell
                temp.level = xlsheet.Cells(irow, 1).Value
                temp.original = xlsheet.Cells(irow, 2).Value.ToString
                temp.type = "Decimals"
                ''    MessageBox.Show(temp.original.ToString + "Level " + temp.level.ToString)
                If Not (decLevels.Contains(temp.level)) Then decLevels.Add(temp.level)
                allProblems.Add(temp)
                irow = irow + 1
                temp = New MathProblem
            Else
                getOut = True
            End If
        End While

        xlsheet = xlwbook.Worksheets("Fractions")
        temp = New MathProblem
        irow = 2 '' to skip the title row
        getOut = False
        While getOut.Equals(False)
            ''MessageBox.Show(xlsheet.Cells(irow, 1).Value)
            If Not xlsheet.Cells(irow, 1).Value = vbNullString Then '' check for empty cell
                temp.level = xlsheet.Cells(irow, 1).Value
                temp.original = xlsheet.Cells(irow, 2).Value.ToString
                temp.type = "Fractions"
                ''   MessageBox.Show(temp.original.ToString + "Level " + temp.level.ToString)
                If Not (fracLevels.Contains(temp.level)) Then fracLevels.Add(temp.level)
                allProblems.Add(temp)
                irow = irow + 1
                temp = New MathProblem
            Else
                getOut = True
            End If
        End While


        ''   MessageBox.Show("I am in here...HHEEELLLPPPP!!!" + allProblems.ToString)
ESCAPE:
    End Sub
    ' Exit Program menu button -  Close the program
    ' TODO: figure out what closing the program entails.
    Private Sub ExitProgramToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitProgramToolStripMenuItem.Click

    End Sub
    ' Profile Page menu button - go to the user's profile page
    Private Sub ProfilePageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProfilePageToolStripMenuItem.Click
        ' check that the user is logged in
        If _userId <> 0 Then
            ' open Profile Page
            ' TODO: write this.
        End If

    End Sub

    '' newer version is on flash drive, Cadre no eat
    ''@todo check for ser profil
    Private Sub SelectTest_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ''cboUsername.Text = Environment.UserName '' adds the currently logged in username to the dropdown menue
        '' Still need to make it automatically fill in field, not have to be selested from drop-down
        '' RAE: Can we make this a simple textbox since Students are going to use this on thier unique login anyway?
        If (FileExists("S:\" + Environment.UserName + ".xml")) Then '' load student profile
            ''If (FileExists(System.AppDomain.CurrentDomain.BaseDirectory(+Environment.UserName + ".xml"))
        Else : Dim Foo As New Student()
        End If
        Dim path As String
        ''path = "S:\" + Environment.UserName + ".xml" '' This is the path for getting it to work on the schools network
        path = System.AppDomain.CurrentDomain.BaseDirectory() + Environment.UserName + ".xml"
        '' MessageBox.Show(path)
        Dim something As New Student(path)




        xcelInit()

    End Sub

    '' this function simply return whether or not a file exhists
    Public Function FileExists(ByVal Fname As String) As Boolean

        If Fname = "" Or Microsoft.VisualBasic.Right(Fname, 1) = "\" Then
            FileExists = False : Exit Function '' basically if it gets bpasses nothing or it gets passed a raw directory, it doesnt exhists
        End If

        FileExists = (Dir(Fname) <> "") '' this is the basic BOOL function in VB to see whether or not a file exhists

    End Function

    
End Class
