﻿Imports System.Xml

'' This class stores all of a students information
'' it is meant to be gathered from a xml file on the student's S: drive
'' and then written back there upon exiting or any intermediate event
Public Class Student
    Public username As String
    Public AddPass(0 To 27) As Boolean '' the index serves as the level and the bool value (t/f) serves as the pass/fail criteria
    Public SubPass(0 To 30) As Boolean
    Public MultPass(0 To 12) As Boolean
    Public DivPass(0 To 19) As Boolean
    Public FractPass(0 To 28) As Boolean
    Public DecPass(0 To 13) As Boolean
    Public PastTests As ArrayList '' arraylist of past tests, each test stores the num correct incorrect and % correct as well as each individual problem and whether or not they passed it

    '' the conctructor gets the XML file of a student and makes a student object
    Public Sub New(ByVal xmlPath As String)
        Dim Doc As XmlDocument = New XmlDocument()
        Doc.Load(xmlPath)

        Dim tempusername As XmlNodeList = Doc.GetElementsByTagName("Student")
        username = tempusername(0).Attributes.GetNamedItem("Student_ID").InnerXml '' holy crap, thats allot to just get the ""  student ID!
        Debug.Print(username)
        For c = 1 To 30 '' for each level available
            Dim tempLevel As XmlNodeList = Doc.GetElementsByTagName("Level_" + c.ToString)
            ''  MessageBox.Show(tempLevel.ToString)
            For x = 0 To tempLevel.Count - 1 '' the above will return a number of instances, one for each catagory, here we go through each and check its catagory
                Debug.Print("Parent Node is " + tempLevel(x).ParentNode.Name) '' check for me to maksure its working
                If tempLevel(x).ParentNode.Name.Contains("Addition") Then '' if its an addition problem

                    AddPass(c) = tempLevel(x).Attributes.GetNamedItem("Passed").InnerXml '' add its result to ADDPass(c)
                    Debug.Print("ïn add, level " + c.ToString + " is " + AddPass(c).ToString)
                ElseIf tempLevel(x).ParentNode.Name.Contains("Subtraction") Then

                    SubPass(c) = tempLevel(x).Attributes.GetNamedItem("Passed").InnerXml
                    Debug.Print("ïn sub, level " + c.ToString + " is " + SubPass(c).ToString)
                ElseIf tempLevel(x).ParentNode.Name.Contains("Multiplication") Then

                    MultPass(c) = tempLevel(x).Attributes.GetNamedItem("Passed").InnerXml
                    Debug.Print("ïn mult, level " + c.ToString + " is " + MultPass(c).ToString)


                ElseIf tempLevel(x).ParentNode.Name.Contains("Division") Then

                    DivPass(c) = tempLevel(x).Attributes.GetNamedItem("Passed").InnerXml
                    Debug.Print("ïn div, level " + c.ToString + " is " + DivPass(c).ToString)

                ElseIf tempLevel(x).ParentNode.Name.Contains("Fractions") Then

                    FractPass(c) = tempLevel(x).Attributes.GetNamedItem("Passed").InnerXml
                    Debug.Print("ïn fract, level " + c.ToString + " is " + FractPass(c).ToString)

                ElseIf tempLevel(x).ParentNode.Name.Contains("Decimals") Then
                    DecPass(c) = tempLevel(x).Attributes.GetNamedItem("Passed").InnerXml
                    Debug.Print("ïn dec, level " + c.ToString + " is " + DecPass(c).ToString)

                Else : Debug.Print("you should never be here")
                End If
            Next
        Next

        'TODO: put in provisions for reading Past Tests
    End Sub

    '' This sub will save the students data to an xml file at the specified path
    Public Sub SaveStudent(ByVal xmlPath As String)

        Dim ymd As String = Date.Now.ToString("yyyyMMdd")
        Dim passed As Boolean
        Dim Doc As New XmlDocument()
        Dim newAtt As XmlAttribute = Doc.CreateAttribute("Student_ID")

        ' Use the XmlDeclaration class to place the
        ' <?xml version="1.0"?> declaration at the top of our XML file
        Dim dec As XmlDeclaration = Doc.CreateXmlDeclaration("1.0", _
                                         Nothing, Nothing)
        Doc.AppendChild(dec)
        Dim ROOT As XmlElement = Doc.CreateElement("ROOT") '' create root node
        Doc.AppendChild(ROOT)
        '' put the students ID at the top of the file (under root)
        Dim student As XmlElement = Doc.CreateElement("Student")
        newAtt.Value = username
        student.Attributes.Append(newAtt)
        Dim currDate As XmlAttribute = Doc.CreateAttribute("Date")
        currDate.Value = ymd
        student.Attributes.Append(currDate)
        ROOT.AppendChild(student)
        '' now for the pass/fail portion
        Dim Catagories As XmlElement = Doc.CreateElement("Catagories")
        student.AppendChild(Catagories)


        Dim x As Integer

        Dim Addition As XmlElement = Doc.CreateElement("Addition")
        Catagories.AppendChild(Addition)
        '' set each of the levels to not passed for a new student
        For x = 1 To 27 '' for each level
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString()) '' set level x
            newAtt = Doc.CreateAttribute("Passed") '' with agttribute passed
            passed = AddPass(x).ToString '' to false
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Addition.AppendChild(Order) '' add to parent node
        Next

        '' new node to house levels of sub
        Dim Subtraction As XmlElement = Doc.CreateElement("Subtraction")
        Catagories.AppendChild(Subtraction)
        For x = 1 To 30
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = SubPass(x).ToString
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Subtraction.AppendChild(Order)
        Next
        '' Create Multiplication node to house multioplication levels
        Dim Multiplication As XmlElement = Doc.CreateElement("Multiplication")
        Catagories.AppendChild(Multiplication)
        For x = 1 To 12
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = MultPass(x).ToString
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Multiplication.AppendChild(Order)
        Next
        '' Create Division node to house division levels
        Dim Division As XmlElement = Doc.CreateElement("Division")
        Catagories.AppendChild(Division)
        For x = 1 To 19
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = DivPass(x).ToString
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Division.AppendChild(Order)
        Next

        '' Create Fraction node to house fraction levels
        Dim Fractions As XmlElement = Doc.CreateElement("Fractions")
        Catagories.AppendChild(Fractions)
        For x = 1 To 28
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = FractPass(x).ToString
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Fractions.AppendChild(Order)
        Next

        '' Create Decimals node to house Decimals levels
        Dim Decimals As XmlElement = Doc.CreateElement("Decimals")
        Catagories.AppendChild(Decimals)
        For x = 1 To 13
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = DecPass(x).ToString
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Decimals.AppendChild(Order)
        Next


        Dim Tests As XmlElement = Doc.CreateElement("Tests") '' future tests go here
        student.AppendChild(Tests)
        Doc.Save(xmlPath)

    End Sub

    Public Sub New()
        Debug.Print("making a new one")
        Dim ymd As String = Date.Now.ToString("yyyyMMddHHmm") '' date and time in sortable format
        Dim passed As Boolean
        Dim Doc As New XmlDocument()
        Dim newAtt As XmlAttribute = Doc.CreateAttribute("Student_ID")

        ' Use the XmlDeclaration class to place the
        ' <?xml version="1.0"?> declaration at the top of our XML file
        Dim dec As XmlDeclaration = Doc.CreateXmlDeclaration("1.0", _
                                         Nothing, Nothing)
        Doc.AppendChild(dec)
        Dim ROOT As XmlElement = Doc.CreateElement("ROOT") '' create root node
        Doc.AppendChild(ROOT)
        '' put the students ID at the top of the file (under root)
        Dim student As XmlElement = Doc.CreateElement("Student")
        newAtt.Value = Environment.UserName
        student.Attributes.Append(newAtt)
        Dim currDate As XmlAttribute = Doc.CreateAttribute("Date")
        currDate.Value = ymd
        student.Attributes.Append(currDate)
        ROOT.AppendChild(student)
        '' now for the pass/fail portion
        Dim Catagories As XmlElement = Doc.CreateElement("Catagories")
        student.AppendChild(Catagories)



        Dim x As Integer

        Dim Addition As XmlElement = Doc.CreateElement("Addition")
        Catagories.AppendChild(Addition)
        '' set each of the levels to not passed for a new student
        For x = 1 To 27 '' for each level
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString()) '' set level x
            newAtt = Doc.CreateAttribute("Passed") '' with agttribute passed
            passed = AddPass(x).ToString '' to false
            newAtt.Value = "False"
            AddPass(x) = False
            Order.Attributes.Append(newAtt)
            Addition.AppendChild(Order) '' add to parent node
        Next

        '' new node to house levels of sub
        Dim Subtraction As XmlElement = Doc.CreateElement("Subtraction")
        Catagories.AppendChild(Subtraction)
        For x = 1 To 30
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = "False"
            SubPass(x) = False
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Subtraction.AppendChild(Order)
        Next
        '' Create Multiplication node to house multioplication levels
        Dim Multiplication As XmlElement = Doc.CreateElement("Multiplication")
        Catagories.AppendChild(Multiplication)
        For x = 1 To 12
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = "False"
            MultPass(x) = False
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Multiplication.AppendChild(Order)
        Next
        '' Create Division node to house division levels
        Dim Division As XmlElement = Doc.CreateElement("Division")
        Catagories.AppendChild(Division)
        For x = 1 To 19
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = "False"
            DivPass(x) = False
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Division.AppendChild(Order)
        Next

        '' Create Fraction node to house fraction levels
        Dim Fractions As XmlElement = Doc.CreateElement("Fractions")
        Catagories.AppendChild(Fractions)
        For x = 1 To 28
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = "False"
            FractPass(x) = False
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Fractions.AppendChild(Order)
        Next

        '' Create Decimals node to house Decimals levels
        Dim Decimals As XmlElement = Doc.CreateElement("Decimals")
        Catagories.AppendChild(Decimals)
        For x = 1 To 13
            Dim Order As XmlNode = Doc.CreateElement("Level_" + x.ToString())
            newAtt = Doc.CreateAttribute("Passed")
            passed = "False"
            DecPass(x) = False
            newAtt.Value = passed.ToString()
            Order.Attributes.Append(newAtt)
            Decimals.AppendChild(Order)
        Next


        Dim Tests As XmlElement = Doc.CreateElement("Tests") '' future tests go here
        student.AppendChild(Tests)
        Doc.Save(System.AppDomain.CurrentDomain.BaseDirectory() + Environment.UserName + ".xml")


    End Sub

End Class
