﻿Imports System.Windows.Forms
Imports MSXML2
Imports Microsoft.Office.Interop

Public Class Login

    Inherits Form
    Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
    Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
    Dim allProblems As ArrayList

    Const DRIVE_REMOVABLE = 2 'Windows default for the declairation of removable
    ' members...
    ' Id number associated with user's name, password, and profile.
    Public UserId As Integer
    ' events
    Event LoginFailed(ByVal sender As Object, ByVal e As EventArgs)
    Event LoginSucceeded(ByVal sender As Object, _
                 ByVal e As EventArgs)
    Event LoginCancelled(ByVal sender As Object, ByVal e As EventArgs)

    ' The user clicks the Guest Account button and goes directly to the Select Test page.
    Private Sub btnGuest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGuest.Click
        ' open Select Test for now.
        Dim oForm As SelectTest
        oForm = New SelectTest()
        oForm.Show()
        oForm = Nothing
    End Sub
    ' The user clicks the Login button and -if the username and password fields are filled
    ' and the UserId is identified, user is redirected to the Profile page.
    Private Sub btnLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogin.Click
        ' Check that the fields have been filled.
        If cboUsername.Text.Trim.Length > 0 Then
            ' TODO: Check the password
            ' For now... the password is 'Drag racer'
            If txtPassword.Text = "Drag racer" Then
                ' For now... user logged in as User1.  hooray
                UserId = 1
                '     Dim newEventArgs As New LoginSucceededEventArgs()
                '  newEventArgs.UserId = UserId
                '  RaiseEvent LoginSucceeded(Me, newEventArgs)
                ' hide the dialog and return
                Me.DialogResult = DialogResult.OK
            End If
        End If

        ' open Profile page.
        Dim oForm As Profile
        oForm = New Profile()
        oForm.Show()
        oForm = Nothing
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        createXML(12345678)
        Me.xcelInit()
    End Sub

    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

    End Sub
    ' This function gets the drive letter of the last inserted flash drive
    Function getLastDrive()
        Dim r&, allDrives$, JustOneDrive$, pos%, DriveType&

        Dim aronedrive(), stickid As String

        allDrives$ = Space$(64)

        r& = GetLogicalDriveStrings(Len(allDrives$), allDrives$)

        allDrives$ = Microsoft.VisualBasic.Left$(allDrives$, r&)

        aronedrive = Split(allDrives, vbNullChar)

        For d = UBound(aronedrive) To 1 Step -1

            If GetDriveType(aronedrive(d)) = DRIVE_REMOVABLE Then stickid = aronedrive(d) : Console.WriteLine(aronedrive(d)) : Exit For

        Next
        If IsDBNull(stickid) Then Return -1

        Return stickid

    End Function



    Public Function createXML(ByVal studentID)
        Dim dom As New MSXML2.DOMDocument60
        dom.async = False
        dom.validateOnParse = False
        dom.resolveExternals = False
        dom.preserveWhiteSpace = True
        '  Debug.Print("asdfasdasd")

        On Error GoTo ErrorHandler
        '   Debug.Print("1")
        ' Create a processing instruction targeted for xml.
        Dim node

        node = dom.createProcessingInstruction("xml", "version='1.0'")
        dom.appendChild(node)
        node = Nothing

        ' Create a processing instruction targeted for xml-stylesheet.
        node = dom.createProcessingInstruction("xml-stylesheet", _
                                "type='text/xml' href='test.xsl'")
        dom.appendChild(node)
        node = Nothing
        '  Debug.Print("2")

        ' Create a comment for the document.
        node = dom.createComment("sample NEW xml file created using XML DOM object.")
        dom.appendChild(node)
        node = Nothing

        ' Create the root element.
        Dim root
        root = dom.createElement("root")

        ' Create a "created" attribute for the root element and
        ' assign the "using dom" character data as the attribute value.
        Dim attr As IXMLDOMAttribute
        attr = dom.createAttribute(studentID)
        attr.value = "using dom"
        root.setAttributeNode(attr)
        attr = Nothing
        '  Debug.Print("3")
        ' Add the root element to the DOM instance.
        dom.appendChild(root)
        ' Insert a newline + tab.
        root.appendChild(dom.createTextNode(vbNewLine + vbTab))
        ' Create and add more nodes to the root element just created.
        ' Create a text element.
        node = dom.createElement("node1")
        Dim ymd As String = Date.Now.ToString("yyyyMMdd")
        node.Text = ymd

        ' Add text node to the root element.
        root.appendChild(node)
        node = Nothing
        ' Add a newline plus tab.
        root.appendChild(dom.createTextNode(vbNewLine + vbTab))
        '    Debug.Print("4")
        ' Create an element to hold a CDATA section.
        node = dom.createElement("node2")


        Dim cd As IXMLDOMCDATASection


        cd = dom.createCDATASection("<Student Records>")
        node.appendChild(cd)
        cd = Nothing
        dom.documentElement.appendChild(node)
        node = Nothing
        ' Add a newline plus tab.
        root.appendChild(dom.createTextNode(vbNewLine + vbTab))

        ' Create an element to hold three empty subelements.
        node = dom.createElement("node3")
        'Debug.Print("5")
        ' Create a document fragment to be added to node3.
        Dim frag As IXMLDOMDocumentFragment
        frag = dom.createDocumentFragment

        ' Add a newline + tab + tab.
        frag.appendChild(dom.createTextNode(vbNewLine + vbTab + vbTab))
        frag.appendChild(dom.createElement("sNODE1"))
        ' Add a newline + tab + tab.
        frag.appendChild(dom.createTextNode(vbNewLine + vbTab + vbTab))
        frag.appendChild(dom.createElement("subNode2"))
        ' Add a newline + tab + tab.
        frag.appendChild(dom.createTextNode(vbNewLine + vbTab + vbTab))
        frag.appendChild(dom.createElement("subNode3"))
        ' Add a newline + tab.
        frag.appendChild(dom.createTextNode(vbNewLine + vbTab))
        node.appendChild(frag)
        frag = Nothing


        root.appendChild(node)
        root.appendChild(dom.createTextNode(vbNewLine + vbTab))
       
        ' Add a newline.
        root.appendChild(dom.createTextNode(vbNewLine))
        node = Nothing
        '  Debug.Print(6)
        ' Save the XML document to a file.
        dom.save("C:\Users\Craig\Desktop\DOM.xml")
        '    Debug.Print("it is done")
        '    Debug.Print("after the save")
        root = Nothing
        dom = Nothing
        Exit Function

ErrorHandler:
        MsgBox(Err.Description)

    End Function
    ' This unction eads expressions from excel files and make MathProblems out of them
    ' It then adds them to allProblems
    Public Function xcelInit()
        Dim xl As New Excel.Application
        Dim xlsheet As New Excel.Worksheet
        Dim xlwbook As Excel.Workbook
        xlwbook = xl.Workbooks.Open("c:\Users\Craig\Documents\book1.xlsx")
        xlsheet = xlwbook.Worksheets("Sheet1")
        For Each cell In xlsheet.Cells
            Dim temp As New MathProblem
            temp.original = cell.Value
            temp.getInternals()
            allProblems.Add(temp)
        Next
        Debug.Print("I am in here...HHEEELLLPPPP!!!")
    End Function
End Class