﻿Public Class MathProblem

    Public args As ArrayList
    Public answer As Integer
    Public operate As ArrayList
    Public original As String ' given as expression
    Public goal As String
    Public type As String


    Public parser As New MTPARSERCOMLib.MTParser

    Function getInternals()
        Dim hasADD, hasSUB, hasMULT, hasDIV As Boolean
        Me.answer = parser.evaluate(original)
        Me.goal = original.ToString + "=" + Me.answer.ToString
        If original.Contains("*") Then
            hasMULT = True
            operate.Add("*")
        End If

        If original.Contains("/") Then
            hasDIV = True
            operate.Add("/")
        End If

        If original.Contains("+") Then
            hasADD = True
            operate.Add("+")
        End If
        If original.Contains("-") Then
            hasSUB = True
            operate.Add("-")
        End If

        If hasMULT Xor hasDIV Xor hasSUB Xor hasADD Then
            If hasMULT Then Me.type = "MULT"
            If hasDIV Then Me.type = "DIV"
            If hasADD Then Me.type = "ADD"
            If hasSUB Then Me.type = "SUB"
        End If

    End Function



End Class
