﻿' Login User 

Imports System.Windows.Forms
Imports Microsoft.Office.Interop
Imports MSXML2
Imports System.Xml

' Imports MSXML2
Public Class LoginUser
    Inherits Form
    ' members...
    Public Tries As Integer
    Public MaxTries As Integer = 3
    Public UserId As Integer

    Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
    Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
    Public allProblems As ArrayList

    Const DRIVE_REMOVABLE = 2

    ' events...
    Event LoginFailed(ByVal sender As Object, ByVal e As EventArgs)
    Event LoginSucceeded(ByVal sender As Object, ByVal e As LoginSucceededEventArgs)
    Event LoginCancelled(ByVal sender As Object, ByVal e As EventArgs)
    Event LoginGuest(ByVal sender As Object, ByVal e As EventArgs)



    ' Go- authenticate the user...
    Public Function Go(ByVal owner As Form) As Integer
        ' reset ourselves
        UserId = 0
        Tries = 0
        ' show ourselves
        Me.ShowDialog(owner)
        ' return the user id back
        Return UserId
    End Function

    ' OK button- log in with the supplied username and password
    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        ' check for username entry
        If cboUsername.Text.Trim.Length > 0 Then
            ' check password.  CAPS sensitive.
            ' TODO: get password from saved file and compare.
            ' For Now... password is Monkey
            If txtPassword.Text = "Monkey" Then
                ' this is a successful login!  hooray!
                ' TODO:  how is the user id stored?  Pass it in here. 
                ' For now... the userid is 1
                UserId = 1
                ' create a new event
                Dim newEventArgs As New LoginSucceededEventArgs
                newEventArgs.UserId = UserId
                RaiseEvent LoginSucceeded(Me, newEventArgs)
                ' hide the dialog and return
                Me.DialogResult = DialogResult.OK
            Else
                ' tell the user that the password was invalid.
                MessageBox.Show("The password you entered was invalid.")
                ' tell the caller that we failed
                RaiseEvent LoginCancelled(Me, New EventArgs())
                ' add one to the number of tries
                Tries += 1
                If Tries = MaxTries Then
                    Me.DialogResult = DialogResult.OK
                End If
            End If
        Else
            MessageBox.Show("You must supply a username.")
        End If
    End Sub

    ' Guest Login - Go to the Select Test page without logging in
    ' TODO: ...that.
    Private Sub btnGuest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGuest.Click
        RaiseEvent LoginGuest(Me, New EventArgs())
        Me.DialogResult = DialogResult.Cancel
    End Sub

    ' TODO: think about putting this somewhere more accessible.
    ' Create XML - 
    


    '' probably dont need this anymore
    Function getLastDrive()
        Dim r&, allDrives$, JustOneDrive$, pos%, DriveType&

        Dim aronedrive(), stickid As String

        allDrives$ = Space$(64)

        r& = GetLogicalDriveStrings(Len(allDrives$), allDrives$)

        allDrives$ = Microsoft.VisualBasic.Left$(allDrives$, r&)

        aronedrive = Split(allDrives, vbNullChar)

        For d = UBound(aronedrive) To 1 Step -1

            If GetDriveType(aronedrive(d)) = DRIVE_REMOVABLE Then stickid = aronedrive(d) : Console.WriteLine(aronedrive(d)) : Exit For

        Next
        If IsDBNull(stickid) Then Return -1

        Return stickid

    End Function

    


    Private Sub LoginUser_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cboUsername.Text = Environment.UserName '' adds the currently logged in username to the dropdown menue
        '' Still need to make it automatically fill in field, not have to be selested from drop-down
        '' RAE: Can we make this a simple textbox since Students are going to use this on thier unique login anyway?
        If (FileExists("S:\" + Environment.UserName + ".xml")) Then '' load student profile
        Else : Dim Foo As New Student()
        End If
        '' Dim path As String
        '' path = System.AppDomain.CurrentDomain.BaseDirectory() + Environment.UserName + ".xml"
        '' MessageBox.Show(path)
        '' Dim something As New Student(path)
    End Sub

    Private Sub cboUsername_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    '' this function simply return whether or not a file exhists
    Public Function FileExists(ByVal Fname As String) As Boolean

        If Fname = "" Or Microsoft.VisualBasic.Right(Fname, 1) = "\" Then
            FileExists = False : Exit Function '' basically if it gets bpasses nothing or it gets passed a raw directory, it doesnt exhists
        End If

        FileExists = (Dir(Fname) <> "") '' this is the basic BOOL function in VB to see whether or not a file exhists

    End Function

End Class