﻿''' <summary> 
''' Stores one item that can be dragged onto the DragTargetControl.
''' </summary>

Public Class DragSource
    Inherits Control

    Protected Overrides Sub OnMouseDown(ByVal e As System.Windows.Forms.MouseEventArgs)
        If Me.BackgroundImage Is Nothing Then Exit Sub
        Dim outDragObject As DragObject = New DragObject(Me.BackgroundImage.Clone)
        AddHandler Me.GiveFeedback, AddressOf outDragObject.RaiseGiveFeedback
        Me.DoDragDrop(outDragObject, DragDropEffects.Copy Or DragDropEffects.None)
        outDragObject.Dispose()
        MyBase.OnMouseDown(e)
    End Sub

End Class

