﻿Public Class ResultsForm

    Private Sub ResultsForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Size of thumbnails
        Dim Width As Integer = 150
        Dim Height As Integer = 100
        Dim inp As IntPtr

        ' display thumbnails of workspaces 
        ' get thumbnails
        Dim thumb1 = TestingPage.result1.resultPic.GetThumbnailImage(Width, Height, Nothing, inp)
        Dim thumb2 = TestingPage.result2.resultPic
        Dim thumb3 = TestingPage.result3.resultPic
        Dim thumb4 = TestingPage.result4.resultPic
        Dim thumb5 = TestingPage.result5.resultPic
        Dim thumb6 = TestingPage.result6.resultPic

        ' Check that there's actually a picture for the thumbnail
        If TestingPage.result1.resultPic IsNot Nothing Then
            Me.PictureBox1.Image = thumb1
        End If

        If TestingPage.result2.resultPic IsNot Nothing Then
            Me.PictureBox2.Image = thumb2.GetThumbnailImage(Width, Height, Nothing, inp)
        End If

        If TestingPage.result3.resultPic IsNot Nothing Then
            Me.PictureBox3.Image = thumb3.GetThumbnailImage(Width, Height, Nothing, inp)
        End If

        If TestingPage.result4.resultPic IsNot Nothing Then
            Me.PictureBox4.Image = thumb4.GetThumbnailImage(Width, Height, Nothing, inp)
        End If

        If TestingPage.result5.resultPic IsNot Nothing Then
            Me.PictureBox5.Image = thumb5.GetThumbnailImage(Width, Height, Nothing, inp)
        End If

        If TestingPage.result6.resultPic IsNot Nothing Then
            Me.PictureBox6.Image = thumb6.GetThumbnailImage(Width, Height, Nothing, inp)
        End If

        ' labels!
        ' put labels under the thumbnails
        lbl1.Text = "11 + 5 = 16"
        lbl1.Location = New Point(PictureBox1.Left, PictureBox1.Bottom + 5)
        urAns1.Text = "You said: " & TestingPage.result1.resultAnswer
        urAns1.Location = New Point(PictureBox1.Left, lbl1.Bottom + 5)

        lbl2.Text = "11 - 5 = 6"
        lbl2.Location = New Point(PictureBox2.Left, PictureBox2.Bottom + 5)
        urAns2.Text = "You said: " & TestingPage.result2.resultAnswer
        urAns2.Location = New Point(PictureBox2.Left, lbl2.Bottom + 5)

        lbl3.Text = "10 x 1.5 = 15"
        lbl3.Location = New Point(PictureBox3.Left, PictureBox3.Bottom + 5)
        urAns3.Text = "You said: " & TestingPage.result3.resultAnswer
        urAns3.Location = New Point(PictureBox3.Left, lbl3.Bottom + 5)

        lbl4.Text = "100 / 5 = 20"
        lbl4.Location = New Point(PictureBox4.Left, PictureBox4.Bottom + 5)
        urAns4.Text = "You said: " & TestingPage.result4.resultAnswer
        urAns4.Location = New Point(PictureBox4.Left, lbl4.Bottom + 5)

        lbl5.Text = "100 / 5 = 20"
        lbl5.Location = New Point(PictureBox5.Left, PictureBox5.Bottom + 5)
        urAns5.Text = "You said: " & TestingPage.result5.resultAnswer
        urAns5.Location = New Point(PictureBox5.Left, lbl5.Bottom + 5)

        lbl6.Text = "1/2 = 5/10"
        lbl6.Location = New Point(PictureBox6.Left, PictureBox6.Bottom + 5)
        urAns6.Text = "You said: " & TestingPage.result6.resultAnswer
        urAns6.Location = New Point(PictureBox6.Left, lbl6.Bottom + 5)

    End Sub

    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click
        If PictureBox1.Image IsNot Nothing Then
            Dim bigView As FullReviewForm
            bigView = New FullReviewForm(TestingPage.result1)
            Dim open As DialogResult = bigView.ShowDialog
        End If
    End Sub

    Private Sub PictureBox2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox2.Click
        If PictureBox2.Image IsNot Nothing Then
            Dim bigView2 As FullReviewForm
            bigView2 = New FullReviewForm(TestingPage.result2)
            Dim open As DialogResult = bigView2.ShowDialog
        End If
    End Sub

    Private Sub PictureBox3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox3.Click
        If PictureBox1.Image IsNot Nothing Then
            Dim bigView3 As FullReviewForm
            bigView3 = New FullReviewForm(TestingPage.result3)
            Dim open As DialogResult = bigView3.ShowDialog
        End If
    End Sub

    Private Sub PictureBox4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox4.Click
        If PictureBox1.Image IsNot Nothing Then
            Dim bigView4 As FullReviewForm
            bigView4 = New FullReviewForm(TestingPage.result4)
            Dim open As DialogResult = bigView4.ShowDialog
        End If
    End Sub

    Private Sub PictureBox5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox5.Click
        If PictureBox1.Image IsNot Nothing Then
            Dim bigView5 As FullReviewForm
            bigView5 = New FullReviewForm(TestingPage.result5)
            Dim open As DialogResult = bigView5.ShowDialog
        End If
    End Sub

    Private Sub PictureBox6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox6.Click
        If PictureBox1.Image IsNot Nothing Then
            Dim bigView6 As FullReviewForm
            bigView6 = New FullReviewForm(TestingPage.result6)
            Dim open As DialogResult = bigView6.ShowDialog
        End If
    End Sub

End Class