﻿''' <summary>
''' TODO: Figure out if you want the user to have to hit the submit button 6 times
''' and THEN the close button.  You know what?  Just make the submit button open the 
''' resultsForm after the 6th problem.
''' </summary>
''' <remarks></remarks>

Public Class TestingPage


#Region " variables "
    ' TODO: get rid of these and use the MathProblem object
    ' 6 AnswerObjects
    Public result1 As New AnswerObject
    Public result2 As New AnswerObject
    Public result3 As New AnswerObject
    Public result4 As New AnswerObject
    Public result5 As New AnswerObject
    Public result6 As New AnswerObject

    Public testProblems As New ArrayList

    Private problemCount As Integer = 1

    ' Buttons!
    Private uxSource0 As DragSource
    Private uxSource1 As DragSource
    Private uxSource2 As DragSource
    Private uxSource3 As DragSource
    Private uxSource4 As DragSource
    Private uxSource5 As DragSource
    Private uxSource6 As DragSource
    Private uxSource7 As DragSource
    Private uxSource8 As DragSource
    Private uxSource9 As DragSource
    Private uxSourceDecimal As DragSource
    Private uxSourceX As DragSource
    Private uxSourceR As DragSource
    Private uxSourceLeftParen As DragSource
    Private uxSourceRightParen As DragSource
    Private uxSourceAdd As DragSource
    Private uxSourceSubtract As DragSource
    Private uxSourceVertBar As DragSource
    Private uxSourceHorizBar As DragSource

    ' 6 workspaces
    ' TODO: make a workspace object and make your life easier
    Private workspace1 As DropTarget
    Private workspace2 As DropTarget
    Private workspace3 As DropTarget
    Private workspace4 As DropTarget
    Private workspace5 As DropTarget
    Private workspace6 As DropTarget

    ' 6 background images for workspaces
    Private display1 As Bitmap
    Private display2 As Bitmap
    Private display3 As Bitmap
    Private display4 As Bitmap
    Private display5 As Bitmap
    Private display6 As Bitmap

    ' problem display
    Private ProblemTopPart1 As DroppedImage

#End Region

#Region " Private "

    ''' <summary>
    ''' Closes the Testing Page and opens the ResultsForm
    ''' TODO: check that all 6 math problems have been completed first
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        ' For now, only need to do 2 math problems
        'If problemCount = 2 Then
        Dim resultsPage As New ResultsForm
        Dim result As DialogResult = resultsPage.ShowDialog
        Me.Dispose()
        'Else
        'MessageBox.Show("Do another math problem thing.")
        'End If
    End Sub

    ''' <summary>
    ''' NEXT button saves the current answer and workspace and creates 
    ''' clean workspace.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        ' Check that something was typed into the answer text field
        If txtAnswer.TextLength < 1 Then
            MessageBox.Show("Please input an answer into the submission field.")
        Else
            MessageBox.Show("Would you like to save " & txtAnswer.Text & " as the answer?")

            ' TODO: User should only click the next button 6 times during a record test
            '       During a practice test... as many times as they want?  or only 6?
            '       NOTE:  If the user is clicking infinite amount of times, they have to
            '       know the answer before they move on.
            ' TODO: Clear the txtAnswer field while clearing the workspace

            If problemCount = 1 Then
                Dim resultPic1 As System.Drawing.Image
                resultPic1 = Me.GetCombinedImage(workspace1)
                result1.resultPic = resultPic1
                result1.resultAnswer = txtAnswer.Text

                ' Clear the workspace and put another one up.
                Controls.Remove(workspace1)
                Me.Controls.Add(workspace2)
            End If

            If problemCount = 2 Then
                Dim resultPic2 As System.Drawing.Image
                resultPic2 = Me.GetCombinedImage(workspace2)
                result2.resultPic = resultPic2
                result2.resultAnswer = txtAnswer.Text

                ' Clear the workspace and put another one up.
                Controls.Remove(workspace2)
                Me.Controls.Add(workspace3)
            End If

            If problemCount = 3 Then
                Dim resultPic3 As System.Drawing.Image
                resultPic3 = Me.GetCombinedImage(workspace3)
                result3.resultPic = resultPic3
                result3.resultAnswer = txtAnswer.Text

                ' Clear the workspace and put another one up.
                Controls.Remove(workspace3)
                Me.Controls.Add(workspace4)
            End If

            If problemCount = 4 Then
                Dim resultPic4 As System.Drawing.Image
                resultPic4 = Me.GetCombinedImage(workspace4)
                result4.resultPic = resultPic4
                result4.resultAnswer = txtAnswer.Text

                ' Clear the workspace and put another one up.
                Controls.Remove(workspace4)
                Me.Controls.Add(workspace5)
            End If

            If problemCount = 5 Then
                Dim resultPic5 As System.Drawing.Image
                resultPic5 = Me.GetCombinedImage(workspace5)
                result5.resultPic = resultPic5
                result5.resultAnswer = txtAnswer.Text

                ' Clear the workspace and put another one up.
                Controls.Remove(workspace5)
                Me.Controls.Add(workspace6)
            End If

            If problemCount = 6 Then
                Dim resultPic6 As System.Drawing.Image
                resultPic6 = Me.GetCombinedImage(workspace6)
                result6.resultPic = resultPic6
                result6.resultAnswer = txtAnswer.Text

                ' Close the TestingPage and go to the ResultsForm
                Dim resultsPage As New ResultsForm
                Dim result As DialogResult = resultsPage.ShowDialog
                Me.Dispose()
            End If

            ' increment problem count 
            problemCount = problemCount + 1

        End If
    End Sub

    ''' <summary>
    ''' Clear the workspace of all drag-n-drop objects
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnClearWorkspace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearWorkspace.Click


    End Sub

    Private Sub btnTestButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTestButton.Click
        ' open CodeTestForm
        Dim CodeTestForm As New CodeTestForm
        Dim test As DialogResult = CodeTestForm.ShowDialog

    End Sub

#End Region

#Region " Public "

    Public Sub New()
        getProblems()
        InitializeComponent()

        ' 7 button control
        uxSource7 = New DragSource
        uxSource7.Location = New Point(10, 30)
        uxSource7.BackColor = Color.WhiteSmoke
        uxSource7.BackgroundImage = My.Resources._7blue
        uxSource7.Size = uxSource7.BackgroundImage.Size
        Me.Controls.Add(uxSource7)

        ' 8 button control
        uxSource8 = New DragSource
        uxSource8.Location = New Point(uxSource7.Right + 5, 30)
        uxSource8.BackColor = Color.WhiteSmoke
        uxSource8.BackgroundImage = My.Resources._8blue
        uxSource8.Size = uxSource8.BackgroundImage.Size
        Me.Controls.Add(uxSource8)

        ' 9 button control
        uxSource9 = New DragSource
        uxSource9.Location = New Point(uxSource8.Right + 5, 30)
        uxSource9.BackColor = Color.WhiteSmoke
        uxSource9.BackgroundImage = My.Resources._9blue
        uxSource9.Size = uxSource9.BackgroundImage.Size
        Me.Controls.Add(uxSource9)

        ' 4 button control
        uxSource4 = New DragSource
        uxSource4.Location = New Point(10, uxSource7.Bottom + 5)
        uxSource4.BackColor = Color.WhiteSmoke
        uxSource4.BackgroundImage = My.Resources._4blue
        uxSource4.Size = uxSource4.BackgroundImage.Size
        Me.Controls.Add(uxSource4)

        ' 5 button control
        uxSource5 = New DragSource
        uxSource5.Location = New Point(uxSource4.Right + 5, uxSource8.Bottom + 5)
        uxSource5.BackColor = Color.WhiteSmoke
        uxSource5.BackgroundImage = My.Resources._5blue
        uxSource5.Size = uxSource5.BackgroundImage.Size
        Me.Controls.Add(uxSource5)

        ' 6 button control
        uxSource6 = New DragSource
        uxSource6.Location = New Point(uxSource5.Right + 5, uxSource7.Bottom + 5)
        uxSource6.BackColor = Color.WhiteSmoke
        uxSource6.BackgroundImage = My.Resources._6blue
        uxSource6.Size = uxSource6.BackgroundImage.Size
        Me.Controls.Add(uxSource6)

        ' 1 button control
        uxSource1 = New DragSource
        uxSource1.Location = New Point(10, uxSource4.Bottom + 5)
        uxSource1.BackColor = Color.WhiteSmoke
        uxSource1.BackgroundImage = My.Resources._1blue
        uxSource1.Size = uxSource1.BackgroundImage.Size
        Me.Controls.Add(uxSource1)

        ' 2 button control
        uxSource2 = New DragSource
        uxSource2.Location = New Point(uxSource1.Right + 5, uxSource5.Bottom + 5)
        uxSource2.BackColor = Color.WhiteSmoke
        uxSource2.BackgroundImage = My.Resources._2blue
        uxSource2.Size = uxSource2.BackgroundImage.Size
        Me.Controls.Add(uxSource2)

        ' 3 button control
        uxSource3 = New DragSource
        uxSource3.Location = New Point(uxSource2.Right + 5, uxSource5.Bottom + 5)
        uxSource3.BackColor = Color.WhiteSmoke
        uxSource3.BackgroundImage = My.Resources._3blue
        uxSource3.Size = uxSource3.BackgroundImage.Size
        Me.Controls.Add(uxSource3)

        ' 0 button control
        uxSource0 = New DragSource
        uxSource0.Location = New Point(uxSource2.Left, uxSource2.Bottom + 5)
        uxSource0.BackColor = Color.WhiteSmoke
        uxSource0.BackgroundImage = My.Resources._0blue
        uxSource0.Size = uxSource0.BackgroundImage.Size
        Me.Controls.Add(uxSource0)

        ' decimal button control
        uxSourceDecimal = New DragSource
        uxSourceDecimal.Location = New Point(uxSource0.Right + 5, uxSource2.Bottom + 5)
        uxSourceDecimal.BackColor = Color.WhiteSmoke
        uxSourceDecimal.BackgroundImage = My.Resources._decimal
        uxSourceDecimal.Size = uxSourceDecimal.BackgroundImage.Size
        Me.Controls.Add(uxSourceDecimal)

        ' X button control
        uxSourceX = New DragSource
        uxSourceX.Location = New Point(uxSource0.Left, uxSource0.Bottom + 5)
        uxSourceX.BackColor = Color.WhiteSmoke
        uxSourceX.BackgroundImage = My.Resources.Xblue
        uxSourceX.Size = uxSourceX.BackgroundImage.Size
        Me.Controls.Add(uxSourceX)

        ' R -remainder button control
        uxSourceR = New DragSource
        uxSourceR.Location = New Point(uxSourceX.Right + 5, uxSource0.Bottom + 5)
        uxSourceR.BackColor = Color.WhiteSmoke
        uxSourceR.BackgroundImage = My.Resources.remainderblue
        uxSourceR.Size = uxSourceR.BackgroundImage.Size
        Me.Controls.Add(uxSourceR)

        ' LeftParen button control
        uxSourceLeftParen = New DragSource
        uxSourceLeftParen.Location = New Point(uxSourceX.Left, uxSourceX.Bottom + 5)
        uxSourceLeftParen.BackColor = Color.WhiteSmoke
        uxSourceLeftParen.BackgroundImage = My.Resources.leftParen
        uxSourceLeftParen.Size = uxSourceLeftParen.BackgroundImage.Size
        Me.Controls.Add(uxSourceLeftParen)

        ' RightParen button control
        uxSourceRightParen = New DragSource
        uxSourceRightParen.Location = New Point(uxSourceLeftParen.Right + 5, uxSourceX.Bottom + 5)
        uxSourceRightParen.BackColor = Color.WhiteSmoke
        uxSourceRightParen.BackgroundImage = My.Resources.rightParen
        uxSourceRightParen.Size = uxSourceRightParen.BackgroundImage.Size
        Me.Controls.Add(uxSourceRightParen)

        ' add button control
        uxSourceAdd = New DragSource
        uxSourceAdd.Location = New Point(uxSourceLeftParen.Left, uxSourceLeftParen.Bottom + 5)
        uxSourceAdd.BackColor = Color.WhiteSmoke
        uxSourceAdd.BackgroundImage = My.Resources.add
        uxSourceAdd.Size = uxSourceAdd.BackgroundImage.Size
        Me.Controls.Add(uxSourceAdd)

        ' subtract button control
        uxSourceSubtract = New DragSource
        uxSourceSubtract.Location = New Point(uxSourceAdd.Right + 5, uxSourceLeftParen.Bottom + 5)
        uxSourceSubtract.BackColor = Color.WhiteSmoke
        uxSourceSubtract.BackgroundImage = My.Resources.subtract
        uxSourceSubtract.Size = uxSourceSubtract.BackgroundImage.Size
        Me.Controls.Add(uxSourceSubtract)

        ' horizontal bar button control
        uxSourceHorizBar = New DragSource
        uxSourceHorizBar.Location = New Point(10, uxSourceAdd.Bottom + 5)
        uxSourceHorizBar.BackColor = Color.WhiteSmoke
        uxSourceHorizBar.BackgroundImage = My.Resources.horizontalBar
        uxSourceHorizBar.Size = uxSourceHorizBar.BackgroundImage.Size
        Me.Controls.Add(uxSourceHorizBar)

        ' vertical bar button control
        uxSourceVertBar = New DragSource
        uxSourceVertBar.Location = New Point(10, uxSource1.Bottom + 8)
        uxSourceVertBar.BackColor = Color.WhiteSmoke
        uxSourceVertBar.BackgroundImage = My.Resources.verticalBar
        uxSourceVertBar.Size = uxSourceVertBar.BackgroundImage.Size
        Me.Controls.Add(uxSourceVertBar)

        ' 6 Workspaces!
        workspace1 = New DropTarget
        workspace1.Location = New Point(uxSourceHorizBar.Right + 20, 10)
        'workspace1.BackgroundImage = My.Resources.gridWorkspace
        'workspace1.Size = workspace1.BackgroundImage.Size
        '' TODO: put this back in once you set up the problem&gridsquares image
        'Me.Controls.Add(workspace1)
        'workspace1.SendToBack()

        workspace2 = New DropTarget
        workspace2.Location = New Point(uxSourceHorizBar.Right + 20, 10)
        workspace2.BackgroundImage = My.Resources.gridWorkspace
        workspace2.Size = workspace2.BackgroundImage.Size

        workspace3 = New DropTarget
        workspace3.Location = New Point(uxSourceHorizBar.Right + 20, 10)
        workspace3.BackgroundImage = My.Resources.gridWorkspace
        workspace3.Size = workspace3.BackgroundImage.Size

        workspace4 = New DropTarget
        workspace4.Location = New Point(uxSourceHorizBar.Right + 20, 10)
        workspace4.BackgroundImage = My.Resources.gridWorkspace
        workspace4.Size = workspace4.BackgroundImage.Size

        workspace5 = New DropTarget
        workspace5.Location = New Point(uxSourceHorizBar.Right + 20, 10)
        workspace5.BackgroundImage = My.Resources.gridWorkspace
        workspace5.Size = workspace5.BackgroundImage.Size

        workspace6 = New DropTarget
        workspace6.Location = New Point(uxSourceHorizBar.Right + 20, 10)
        workspace6.BackgroundImage = My.Resources.gridWorkspace
        workspace6.Size = workspace6.BackgroundImage.Size



        ' call the function 6 times to assign images to the display bitmaps

        ' TEST: put a 5 in the top part of the problem
        ' test mathProblem
        Dim testProblem As New MathProblem
        testProblem.original = "5+4"
        testProblem.operate = "+"

        display1 = DisplayMathProblem(testProblem, workspace1)

        workspace1.BackgroundImage = display1
        workspace1.Size = workspace1.BackgroundImage.Size
        Me.Controls.Add(workspace1)



        ' submission thingie bobs

        txtAnswer.Location = New Point(workspace1.Left, workspace1.Bottom + 15)
        btnNext.Location = New Point(txtAnswer.Right + 10, workspace1.Bottom + 15)
        btnClose.Location = New Point(btnNext.Right + 10, workspace1.Bottom + 15)
        btnClearWorkspace.Location = New Point(workspace1.Right + 15, 30)


        ' button to bring up the workspace image
        btnTestButton.Location = New Point(btnClearWorkspace.Left, btnClearWorkspace.Bottom + 5)

    End Sub

    ''' <summary>
    ''' Returns a slightly bigger rectangle than the one passed in.
    ''' Note:  When you invalidate a rectangle it always misses a bit.
    ''' </summary> 
    Public Function SlightlyBiggerRectangle(ByVal recIn As Rectangle) As Rectangle
        Return New Rectangle(recIn.X - 2, recIn.Y - 2, recIn.Width + 5, recIn.Height + 5)
    End Function

    ''' <summary>
    ''' Grabs the image of the workspace.
    ''' </summary>
    Public Function GetCombinedImage(ByVal target As DropTarget) As Bitmap
        ' create a bitmap to hold the image
        Dim combinedImage As New Bitmap(target.BackgroundImage.Width, target.BackgroundImage.Height)
        ' clear the selection rectangle -we don't want it in the final image.
        target.ClearSelection()
        ' Tell the control to draw itself into a bitmap
        target.DrawToBitmap(combinedImage, New Rectangle(New Point(0, 0), combinedImage.Size))
        Return combinedImage
    End Function

    ''' <summary>
    ''' Clears workspace.  returns original workspace.
    ''' </summary>
    ''' <param name="target"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function ClearWorkspace(ByVal target As DropTarget) As Bitmap
        Dim origImage As Bitmap
        origImage = target.BackgroundImage

        Return origImage
    End Function

    '''<summary>
    ''' For multiplication, addition, subtraction, (decimals?)
    ''' Display the math problems on the workspace, save entire workspace as an image.
    ''' </summary>
    Public Function DisplayMathProblem(ByVal maths As MathProblem, ByVal workspace As DropTarget) As Bitmap
        ' given MathProblem
        Dim mathyProblem As New MathProblem
        mathyProblem = maths

        ' TODO: check that the given math problem IS a proper MathProblem
        ' Only categories addition, subtraction, multiplication, (decimals?)
        ' Else return error

        ' base image: gridWorkspace
        Dim base As New Bitmap(My.Resources.gridWorkspace)
        ' Dumping ground
        Dim g As Graphics = Graphics.FromImage(base)
        ' final image to return
        Dim tada As Bitmap

        ' TODO: figure out how many digits you need.  BTW, you DIM way way too much.
        ' 5 digits of the 1st argument, as images
        Dim firstArg1 As Bitmap
        'Dim secondArg1 As Bitmap
        'Dim thirdArg1 As Bitmap
        'Dim fourthArg1 As Bitmap
        'Dim fifthArg1 As Bitmap

        ' 5 digits of the 2nd argument, as images
        Dim firstArg2 As Bitmap
        'Dim secondArg2 As Bitmap
        'Dim thirdArg2 As Bitmap
        'Dim fourthArg2 As Bitmap
        'Dim fifthArg2 As Bitmap

        ' operator (+, -, x), as image
        Dim op As Bitmap

        ' equals bar(s) as an image
        Dim eBar1 As New Bitmap(My.Resources.horizontalBar)
        'Dim eBar2 As Bitmap

        ' get length of the first argument
        Dim length As Integer
        length = 1
        ' TODO: get the parsed string, so you can pass it in one character at a time
        ' for each of the numbers in the first argument, assign the correct image.

        firstArg1 = AssignCorrectImage("1")


        ' TODO: double check string comparisons
        ' for the operator, assign the correct image.
        If mathyProblem.operate = "+" Then
            op = New Bitmap(My.Resources.add)
        End If
        If mathyProblem.operate = "-" Then
            op = New Bitmap(My.Resources.subtract)
        End If
        If mathyProblem.operate = "*" Then
            op = New Bitmap(My.Resources.multiply)
        End If



        ' for each of the numbers in the second argument, assign the correct image.
        firstArg2 = AssignCorrectImage("4")

        ' The location of the left-most image of the 1st argument in the workspace
        Dim location1Arg1 As New Point(183, 124)
        ' The location of the left-most-minus-one image of the 1st argument
        Dim location2Arg1 As New Point(243, 124)
        ' The location of the left-most-minus-two image of the 1st argument
        Dim location3Arg1 As New Point(303, 124)
        ' The location of the left-most-minus-three image of the 1st argument
        Dim location4Arg1 As New Point(363, 124)
        ' The location of the left-most-minus-four image of the 1st argument
        Dim location5Arg1 As New Point(423, 124)

        ' The location of the left-most image of the 2nd argument in the workspace
        Dim location1Arg2 As New Point(183, 184)
        ' The location of the left-most-minus-one of the 2nd argument
        Dim location2Arg2 As New Point(243, 184)
        ' The location of the left-most-minus-two of the 2nd argument
        Dim location3Arg2 As New Point(303, 184)
        ' The location of the left-most-minus-three image of the 2nd argument
        Dim location4Arg2 As New Point(363, 184)
        ' The location of the left-most-minus-four image of the 2nd argument
        Dim location5Arg2 As New Point(423, 184)

        ' The location of the operator
        Dim locationOper As New Point(123, 184)

        ' TODO: double check the location points
        ' The location of the equals bar
        Dim locationBar1 As New Point(123, 214)  ' left
        Dim locationBar2 As New Point  ' right (extension)

        ' TODO: Draw all images to correct locations


        ' merge images, but only the images that have been assigned
        g.DrawImage(base, 0, 0)    ' gridWorkspace image
        g.DrawImage(firstArg1, location1Arg1)  ' first argument
        g.DrawImage(firstArg2, location1Arg2)  ' second argument

        g.DrawImage(op, locationOper)  ' operater
        g.DrawImage(eBar1, locationBar1)  ' left side of the equals bar
        'g.DrawImage(eBar2, locationBar2)  ' right side of the equals bar

        ' Return the ready workspace as a Bitmap
        tada = base
        Return tada

    End Function

    Private Function AssignCorrectImage(ByVal number As String) As Bitmap

        Dim needsMatch As String
        needsMatch = number

        Dim correctMatch As Bitmap

        If needsMatch = "0" Then
            correctMatch = New Bitmap(My.Resources._0)
            Return correctMatch
        End If
        If needsMatch = "1" Then
            correctMatch = New Bitmap(My.Resources._1)
            Return correctMatch
        End If
        If needsMatch = "2" Then
            correctMatch = New Bitmap(My.Resources._2)
            Return correctMatch
        End If
        If needsMatch = "3" Then
            correctMatch = New Bitmap(My.Resources._3)
            Return correctMatch
        End If
        If needsMatch = "4" Then
            correctMatch = New Bitmap(My.Resources._4)
            Return correctMatch
        End If
        If needsMatch = "5" Then
            correctMatch = New Bitmap(My.Resources._5)
            Return correctMatch
        End If
        If needsMatch = "6" Then
            correctMatch = New Bitmap(My.Resources._6)
            Return correctMatch
        End If
        If needsMatch = "7" Then
            correctMatch = New Bitmap(My.Resources._7)
            Return correctMatch
        End If
        If needsMatch = "8" Then
            correctMatch = New Bitmap(My.Resources._8)
            Return correctMatch
        End If
        If needsMatch = "9" Then
            correctMatch = New Bitmap(My.Resources._9)
            Return correctMatch
        End If

    End Function

#End Region


    Private Sub TestingPage_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Sub getProblems()
        MessageBox.Show("PLease get here")
        Dim catagory As String
        Dim level As String
        catagory = SelectTest.CategoryChoice
        level = SelectTest.LevelChoice
        ' Diagnostic
        ''level = 3
        ''catagory = "addition"
        level = level.Substring(level.Length - 1)
        Dim myProblems As Array
        myProblems = SelectTest.allProblems.ToArray
        Dim i As Integer

        For i = 0 To myProblems.Length - 1
            ''MessageBox.Show("problem level and type " + myProblems(i).level.ToString + " " + myProblems(i).type.ToString + "and the level and catagory is " + level + " " + catagory)
            If (myProblems(i).level.ToString.Equals(level) And myProblems(i).type.ToString.Equals(catagory)) Then
                testProblems.Add(myProblems(i))
                MessageBox.Show("Adding " + myProblems(i).original)
            End If
        Next
        '' removing random problems is over 6
        Dim RandomClass As New Random()
        Dim RandomNumber As Integer
        If (testProblems.Count > 6) Then '' if over 6
            While (testProblems.Count > 6) '' while over 6
                RandomNumber = RandomClass.Next(0, testProblems.Count)
                testProblems.RemoveAt(RandomNumber) '' remove random problem in the arraylist
            End While
        End If

    End Sub
End Class
